import { EventAggregator }             from "aurelia-event-aggregator";
import { Router, RouterConfiguration } from "aurelia-router";
import { PitayaAppViewCustomElement }  from "../components/pitaya-app-view";
import { PitayaView }                  from "./view";

export declare abstract class PitayaApp
{
	public viewTransition: string;
	public appView: PitayaAppViewCustomElement;
	public currentView: PitayaView;
	public isOnline: boolean;
	public theme: string;
	public enableControls: boolean;

	static instance(): PitayaApp;

	protected constructor( eventAggregator: EventAggregator );

	public configureRouter( config: RouterConfiguration, router: Router ): Promise<void>;

	/* TODO: Add parameters */
	public activate(): Promise<void>;

	public created( parentContext, context );

	/* TODO: Add parameters */
	public bind();

	public attached();

	public detached();

	public navigate( routeName: string, options?: any ): Promise<void>;

	public navigateBack();

	public setStatusBarColor( color: string );
}

export declare function overrideBrowserBackButton( callback: Function );

export declare function enableScrolling( enable: boolean );

export declare function setStatusBarColor( color: string );

export declare function navigate( routeName: string, options?: any );

export declare function navigateBack();

export declare function enableControls( enable: boolean );