import { NavigationInstruction, RedirectToRoute, RouteConfig } from "aurelia-router";
import { IScrollMarkerHandlerConfig, IViewStates }             from "../../types";

export declare abstract class PitayaView
{
	public rootElement: HTMLElement;
	public states: IViewStates;
	public innerElement: HTMLElement;

	static instance(): PitayaView;

	public canActivate( params: any, routeConfig: RouteConfig, navigationInstruction: NavigationInstruction ): boolean | RedirectToRoute | Promise<boolean | RedirectToRoute>;

	public activate( params, routeConfig, navigationInstruction );

	public created( parentContext, context );

	public bind( bindingContext, overrideContext );

	public attached();

	public detached()

	public navigate( route: string, options?: any ): Promise<void>

	public queueAnimationTask( task: Function );

	public setTheme( color: string );
}

export declare function scrollToTop( scrollDuration: number ): void;

export declare function setScrollMarkerHandler( { element, className, minHeight, maxHeight }: IScrollMarkerHandlerConfig ): () => void;